<script lang="ts" setup>
import { ref, computed, onMounted, nextTick } from 'vue';
import { numberToDigitString } from '@/utils/numberToDigitString';
import { ChevronLgRight, ChevronLgLeft } from 'slippers-ui/icons';
import type { BaseImage } from '@/types/base';

interface Quote {
  quote: string;
  author: string;
  logo: BaseImage;
  config: {
    href: string;
    dataGaName: string;
    dataGaLocation: string;
  };
}

interface CarouselData {
  quotes: Array<Quote>;
}

const props = defineProps<CarouselData>();

const content = ref<HTMLElement | null>(null);
const currentIndex = ref(0);
const innerStyles = ref({});
const transitioning = ref(false);

const step = computed(() => {
  if (!content.value) return '0px';
  const innerWidth = content.value.scrollWidth;
  const totalItems = props.quotes.length;
  return `${innerWidth / totalItems}px`;
});

const formattedStep = computed(() => {
  return `${numberToDigitString(currentIndex.value + 1)} - ${numberToDigitString(props.quotes.length)}`;
});

const resetTranslate = () => {
  innerStyles.value = {
    transform: 'translateX(0)',
    transition: 'none',
  };
};

const goNext = () => {
  if (transitioning.value) return;
  transitioning.value = true;

  currentIndex.value = currentIndex.value >= props.quotes.length - 1 ? 0 : currentIndex.value + 1;

  nextTick(() => {
    innerStyles.value = {
      transform: `translateX(-${step.value})`,
      transition: 'transform 0.35s cubic-bezier(0.94, 0.7, 0.46, 0.92)',
    };

    const listener = () => {
      resetTranslate();
      transitioning.value = false;
      content.value?.removeEventListener('transitionend', listener);
    };
    content.value?.addEventListener('transitionend', listener);
  });
};

const goPrev = () => {
  if (transitioning.value) return;
  transitioning.value = true;

  currentIndex.value = currentIndex.value <= 0 ? props.quotes.length - 1 : currentIndex.value - 1;

  nextTick(() => {
    innerStyles.value = {
      transform: `translateX(${step.value})`,
      transition: 'transform 0.35s cubic-bezier(0.94, 0.7, 0.46, 0.92)',
    };

    const listener = () => {
      resetTranslate();
      transitioning.value = false;
      content.value?.removeEventListener('transitionend', listener);
    };
    content.value?.addEventListener('transitionend', listener);
  });
};

onMounted(() => {
  resetTranslate();
});
</script>

<template>
  <div
    id="quotes"
    class="quotes-carousel"
    aria-roledescription="carousel"
    aria-label="Customer quotes"
    aria-live="polite"
  >
    <div class="quotes-carousel__header" />
    <div class="carousel">
      <div ref="content" class="carousel__wrapper">
        <div class="carousel__content" :style="innerStyles">
          <SalesQuoteCard
            v-for="quote in quotes"
            :key="quote.author"
            class="quotes-carousel__quote"
            v-bind="quotes[currentIndex]"
          />
        </div>
      </div>
    </div>
    <div v-if="props.quotes.length > 1" class="quotes-carousel__footer">
      <SlpTypography tag="span" variant="body1">
        {{ formattedStep }}
      </SlpTypography>
      <div>
        <SlpButton
          class="slp-color-primary-200"
          variant="icon"
          aria-label="Previous quote"
          aria-controls="quotes"
          @click="goPrev"
        >
          <SlpIcon :icon="ChevronLgLeft" />
        </SlpButton>
        <SlpButton
          class="slp-color-primary-200"
          variant="icon"
          aria-label="Next quote"
          aria-controls="quotes"
          @click="goNext"
        >
          <SlpIcon class="slp-ml-8" :icon="ChevronLgRight" />
        </SlpButton>
      </div>
    </div>
  </div>
</template>

<style scoped lang="scss">
.quotes-carousel {
  margin: $spacing-96 0;

  &__header {
    display: flex;
    flex-direction: column;
    padding-bottom: $spacing-32;
    border-bottom: 2px solid $color-surface-400;

    @media (min-width: $breakpoint-md) {
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
    }

    :deep(a) {
      @media (max-width: $breakpoint-md) {
        padding-left: 0;
      }
    }
  }

  &__quote {
    display: inline-flex;
    margin-right: $spacing-16;
    flex: 0 0 100%;
  }

  &__footer {
    display: flex;
    justify-content: space-between;
    align-items: center;
    padding: $spacing-16 0;
  }
}

.carousel {
  width: 100%;

  &__wrapper {
    width: 100%;
    height: 100%;
    padding: $spacing-48 $spacing-16;
    overflow: hidden;
    position: relative;
    border-bottom: 2px solid #a2a1a6;
  }

  &__content {
    display: flex;
  }
}
</style>
